package edu.mermet.tp8.fenetres;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ButtonGroup;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JRadioButton;

import java.awt.event.WindowEvent;
import java.awt.event.WindowAdapter;

import edu.mermet.tp8.Application;

public class DialogOption extends JDialog {
    public DialogOption(Application frame, JMenu menu) {
        super(frame, "Configuration des menus", true);

        JPanel radioPan = new JPanel(new GridLayout(menu.getItemCount(), 4));
        for (int i = 0; i < menu.getItemCount(); i++) {
            JMenuItem item = menu.getItem(i);
            radioPan.add(new JLabel(item.getLabel()));

            ButtonGroup group = new ButtonGroup();
            JRadioButton auto = new JRadioButton(new AutoAction(item));
            radioPan.add(auto);
            group.add(auto);
            JRadioButton show = new JRadioButton(new ShowAction(item));
            radioPan.add(show);
            group.add(show);
            JRadioButton hide = new JRadioButton(new HideAction(item));
            radioPan.add(hide);
            group.add(hide);
        }
        add(radioPan);

        setDefaultCloseOperation(HIDE_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
            @Override
            public void windowClosing(WindowEvent we) {
                frame.enableOption(true);
            }
        });

        pack();
        setLocationRelativeTo(null);
    }

    class AutoAction extends AbstractAction {
        private JMenuItem item;
        public AutoAction(JMenuItem item) {
            super("Auto");
            this.item = item;
        }

        public void actionPerformed(ActionEvent ae) {

        }
    }

    class ShowAction extends AbstractAction {
        private JMenuItem item;
        public ShowAction(JMenuItem item) {
            super("Affiché");
            this.item = item;
        }

        public void actionPerformed(ActionEvent ae) {
            item.setVisible(true);
        }
    }

    class HideAction extends AbstractAction {
        private JMenuItem item;
        public HideAction(JMenuItem item) {
            super("Caché");
            this.item = item;
        }

        public void actionPerformed(ActionEvent ae) {
            item.setVisible(false);
        }
    }
}
